#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1500four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 1500"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire1500four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four15004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2four15004xi = {
                1:'1006x-421y1028z',
                2:'101x-287y1468z',
                3:'1026x-712y829z',
                4:'1037x-371y1018z',
                5:'104x-71y1494z',
                6:'1055x-1055y145z',
                7:'1064x-319y1006z',
                8:'1069x-662y816z',
                9:'1089x-265y995z',
                10:'1110x-609y804z',
                11:'1110x-999y130z',
                12:'1112x-210y984z',
                13:'1131x-153y973z',
                14:'1147x-553y791z',
                15:'1147x-94y961z',
                16:'1160x-34y950z',
                17:'1162x-941y115z',
                18:'1182x-495y778z',
                19:'1210x-879y100z',
                20:'121x-73y1493z',
                21:'122x-295y1465z',
                22:'1255x-815y85z',
                23:'1294x-464y817z',
                24:'1297x-749y70z',
                25:'1335x-680y55z',
                26:'1369x-609y40z',
                27:'138x-74y1491z',
                28:'1400x-537y25z',
                29:'1426x-463y10z',
                30:'143x-301y1462z',
                31:'152x-1453y337z',
                32:'155x-73y1490z',
                33:'166x-306y1458z',
                34:'172x-71y1488z',
                35:'189x-310y1455z',
                36:'190x-66y1486z',
                37:'207x-61y1484z',
                38:'214x-311y1451z',
                39:'225x-53y1482z',
                40:'229x-1446y323z',
                41:'238x-311y1447z',
                42:'242x-44y1479z',
                43:'245x-596y1354z',
                44:'258x-33y1477z',
                45:'264x-309y1443z',
                46:'274x-21y1474z',
                47:'282x-595y1347z',
                48:'290x-305y1439z',
                49:'290x-7y1471z',
                50:'305x-1435y308z',
                51:'316x-300y1435z',
                52:'319x-591y1340z',
                53:'342x-292y1430z',
                54:'357x-585y1334z',
                55:'368x-282y1426z',
                56:'380x-1420y293z',
                57:'394x-271y1421z',
                58:'394x-577y1327z',
                59:'400x-847y1171z',
                60:'420x-257y1416z',
                61:'432x-566y1320z',
                62:'445x-242y1411z',
                63:'449x-835y1161z',
                64:'455x-1401y279z',
                65:'469x-552y1312z',
                66:'470x-224y1406z',
                67:'494x-205y1401z',
                68:'498x-820y1152z',
                69:'507x-536y1305z',
                70:'517x-183y1395z',
                71:'529x-1378y264z',
                72:'539x-160y1390z',
                73:'544x-518y1298z',
                74:'547x-802y1142z',
                75:'553x-1030y938z',
                76:'561x-134y1384z',
                77:'580x-107y1378z',
                78:'580x-497y1290z',
                79:'595x-782y1132z',
                80:'599x-79y1372z',
                81:'601x-1351y249z',
                82:'611x-1008y926z',
                83:'615x-474y1282z',
                84:'616x-48y1366z',
                85:'631x-16y1360z',
                86:'643x-758y1122z',
                87:'650x-449y1274z',
                88:'668x-982y914z',
                89:'672x-1320y234z',
                90:'683x-421y1267z',
                91:'689x-731y1112z',
                92:'715x-390y1258z',
                93:'724x-953y902z',
                94:'735x-702y1102z',
                95:'741x-1284y219z',
                96:'746x-358y1250z',
                97:'76x-1456y352z',
                98:'775x-323y1242z',
                99:'779x-670y1092z',
                100:'779x-921y890z',
                101:'803x-286y1233z',
                102:'809x-1246y205z',
                103:'821x-635y1082z',
                104:'829x-247y1225z',
                105:'832x-885y878z',
                106:'852x-206y1216z',
                107:'862x-597y1071z',
                108:'874x-1203y190z',
                109:'874x-164y1207z',
                110:'884x-846y866z',
                111:'893x-119y1198z',
                112:'89x-68y1495z',
                113:'901x-557y1061z',
                114:'910x-73y1189z',
                115:'925x-26y1180z',
                116:'934x-804y854z',
                117:'937x-1157y175z',
                118:'939x-514y1050z',
                119:'974x-468y1039z',
                120:'981x-760y841z',
                121:'997x-1108y160z'}
#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire1500four4xi" usage = "target function for charge15004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire1500four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE1500FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE1500FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE1500FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE1500FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE1500FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four15004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE1500FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE1500FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE1500FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four15004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four15004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE1500FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE1500FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE1500FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1500four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                    